/*************************************************
**      To: qt_nvclock.h
** Project: nvclock
**  Author: Jan Prokop
**  e-mail: jprokop@ibl.sk
*************************************************/

#ifndef QT_NVCLOCK
#define QT_NVCLOCK

#include <qtabdialog.h>
#include <qtextbrowser.h>

#include "backend.h"

class QSpinBox;
class QCheckBox;
class QComboBox;
class QGridLayout;

//------------------------------------------------------------------

class CTabNVidia : public QWidget {
    Q_OBJECT
        
public:
    CTabNVidia(QWidget *parent, char *name);

public slots:
    int  slotGo();
    int  slotLoad(int id);
    
private:
    QComboBox   *comboCardNo;
    QSpinBox    *spinCore, *spinMemory;
    QCheckBox   *checkDebug;
    QGridLayout *l;

    struct card nvcard[10];
    int  total_cards;

    void addLabel(const QString &text, int yy);
    int  getCards();
};

//------------------------------------------------------------------
              
class CNVclock : public QTabDialog
{
    Q_OBJECT

public:
    CNVclock(QWidget *parent, char *name);

protected:
    QTextBrowser *initAbout();
    QTextBrowser *initLinks();
};
#endif
